package org.nm.challenge.display;

import org.jfree.ui.ApplicationFrame;
import org.jfree.ui.RefineryUtilities;
import org.nm.challenge.arrays.Array2D;
import org.nm.challenge.arrays.IArray2D;

public class JFreeChartDisplayFrame extends ApplicationFrame implements IDisplay {

	private static final long serialVersionUID = 1L;
	private static final int NDATA = 11;

	/**
	 * Starting point for the demonstration application.
	 *
	 * @param args ignored.
	 * @throws InterruptedException 
	 */
	public static void main(String[] args) throws InterruptedException {
		JFreeChartDisplayFrame demo = new JFreeChartDisplayFrame();
		demo.pack();
		RefineryUtilities.centerFrameOnScreen(demo);
		demo.setVisible(true);
		Array2D mass = new Array2D(3*NDATA, 20);
		for (int t = 1; t<3*NDATA; ++t) {
			double[][] dmass = mass.getData();
			for (int i = 0; i<10; ++i) {
				for (int j = 0; j<20; ++j) {
					dmass[i][j] += 10 + (i+1)*Math.sin(i)*Math.cos(j);
				}
			}
			Thread.sleep(1000);
			System.out.println("updating display");
			demo.update(t, mass);
		}
		
	}

	private JFreeChartDisplayPanel chartDisplay;
	
	public JFreeChartDisplayFrame() {
		super("display");
		chartDisplay = new JFreeChartDisplayPanel();
		setContentPane(chartDisplay);
	}
	
	public void update(final int iteration, final IArray2D mass) {
		chartDisplay.update(iteration, mass);
	}
}
